void test_eeprom30(void)
  {
    zobraz_text(14);                                                                  //  "EE-30"
    byte pomprom0 = EEPROM_read30(0);                                                 // puvodni hodnota na adrese 0 se zapamatuje
    byte pomprom32 = EEPROM_read30(32768);                                            // puvodni hodnota na adrese 32768 se zapamatuje

    Serial.print("puvodni hodnota na adrese [00000] = ");
    Serial.println(pomprom0);
    Serial.print("puvodni hodnota na adrese [32768] = ");
    Serial.println(pomprom32);

     
    EEPROM_write30(0, 123);                                                           // na adresu 0 se zapise nejake cislo (123)
    EEPROM_write30(32768, 234);                                                       // pokud je osazena pamet jen 32kB, dojde k preteceni adresy 32768 na 0 a prepise se hodnota 123 na adrese nula cislem 234
    byte pomprom = EEPROM_read30(0);                                                  // znovu se precte adresa 0
    if (pomprom == 123) Serial.println("Kapacita 64kB");                              // puvodni hodnota se neprepsala, obsahuje cislo 123
    if (pomprom == 234) Serial.println("Kapacita 32kB");                              // puvodni hodnota se prepsala, obsahuje cislo 234
    if (pomprom !=123 and pomprom != 234) Serial.println("Chyba pameti");             // zapis se nepodaril (pamet obsahuje 0, 100, nebo 255)

    EEPROM_write30(0, pomprom0);                                                      // obnoveni puvodnich hodnot
    EEPROM_write30(32768, pomprom32);


    


  }



//----------------------------------------------
// cteni 1 bajtu ze zasuvne EEPROM
byte EEPROM_read30(unsigned int addr)
  {
    delayMicroseconds(7);
    Wire.beginTransmission(87);                                                       // zacatek komunikace s EEPROM
    Wire.write(byte(addr >> 8));                                                      // MSB z adresy
    Wire.write(byte(addr % 256));                                                     // LSB z adresy
    byte err = Wire.endTransmission();                                                // konec komunikace
    if (err > 0) Serial.println("Chyba I2C cteni");;
    delayMicroseconds(2);
    Wire.requestFrom(87, 1);
    return Wire.read();
  }
//----------------------------------------------



//----------------------------------------------
// zapis jednoho bajtu do externi EEPROM
void EEPROM_write30(unsigned int adresa, byte data)
  {
    delay(5);
    Wire.beginTransmission(87);                                                       // zacatek komunikace s EEPROM
    Wire.write(byte(adresa >> 8));                                                    // MSB z adresy
    Wire.write(byte(adresa % 256));                                                   // LSB z adresy
    delay(1);
    Wire.write(data);                                                                 // ulozeni hodnoty
    byte err = Wire.endTransmission();                                                // konec komunikace
    if (err > 0) Serial.println("Chyba I2C zapisu");
    delay(5);
  }
//----------------------------------------------
