
void cyk_interrupt(void)
  {
    zobraz_text(9);                                                                  //  "tLAC "
    Serial.println("Test funkce tlacitek.");

    while (true)
      {

        Serial.print(" Stiskni a drz tlacitko ... ");
        tlacitko = 0;
        zakmity = 0;                                           

        start_testu = millis(); 
        trvani_testu = 10000;                                                        // pred prvnim interruptem se nastavi delka trvani testovani tlacitka na 10 sekund
        while (millis() - start_testu < trvani_testu)  ;                             // testuje se 10 sekund v pripade, ze k zadnemu interruptu nedojde, nebo 2 sekundy od prvniho pruchodu interruptem
        

        if (tlacitko == 0)                                                           // behem 10 sekund nedoslo ani k jednomu interruptu
          {
            Serial.println("\nV intervalu 10 sekund nebylo zadne tlacitko stisknuto - KONEC TESTU.");
            break;                                                                   // vypadne ze smycky while (true)
          }

        switch (tlacitko)
          {
            case 1:
              Serial.print("[NAHORU]");
              break;
            case 2:
              Serial.print("[DOLU]  ");
              break;
            case 3:
              Serial.print("[OK]    ");
              break;
            case 4:
              Serial.print("[TS]    ");
              break;
          }
   
        Serial.print("   Zakmity = ");
        Serial.print(zakmity);
        Serial.print("   Trvani = ");
        Serial.print(posledni_kmit - prvni_zmena);                                   // trvani je rozdil casu prvni_zmeny a posledniho kmitu v mikrosekundach
        Serial.print(" [us] ");
    

        zakmity = 0;
        tlacitko = 0;

        prvni_zmena = micros();                                                      // vynulovani intervalu pro pripad, ze by pri rozpinani nedoslo k zadnemu interruptu
        posledni_kmit = prvni_zmena;

        
        Serial.print("  Uvolni tlacitko ... ");

        start_testu = millis(); 
        trvani_testu = 10000;                                                        // pred prvnim interruptem se nastavi delka trvani testovani tlacitka na 10 sekund
        while (millis() - start_testu < trvani_testu)  ;                             // testuje se 10 sekund v pripade, ze k zadnemu interruptu nedojde, nebo 2 sekundy od prvniho pruchodu interruptem

        
        if (tlacitko == 0)                                                           // behem 10 sekund nedoslo ani k jednomu interruptu
          {
            Serial.println("\nV intervalu 10 sekund nebylo zadne tlacitko uvolneno - KONEC TESTU.");
            break;                                                                   // vypadne ze smycky while (true)
          }


        Serial.print("   Zakmity = ");
        Serial.print(zakmity);
        Serial.print("   Trvani = ");
        Serial.print(posledni_kmit - prvni_zmena);                                   // trvani je rozdil casu prvni_zmeny a posledniho kmitu v mikrosekundach
        Serial.println(" [us] ");
      }
             
  }



void interUP(void)
  { 
    if (tlacitko == 0)
      {
        prvni_zmena = micros();                                                      // znacka pro vypocet delky kmitani v mikrosekundach
        start_testu = millis();                                                      // znacka pro 2-sekundovy interval testovani zakmitu
        trvani_testu = 2000;                                                         // trvani testu se nastavi na 2 sekundy od prvniho pruchodu interruptem
        tlacitko = 1;                                                                // znacka, ze bylo stisknute tlacitko cislo 1 (nahoru)
      }
    posledni_kmit = micros();                                                        // zaznam casu posledniho kmitnuti v mikrosekundach (kdyz je jen jeden zakmit, bude o neco vetsi nez prvni_zmena)
    zakmity ++;                                                                      // pricteni jednoho zakmitu
  }



void interDN(void)
  { 
    if (tlacitko == 0)
      {
        prvni_zmena = micros();                                                      // znacka pro vypocet delky kmitani v mikrosekundach
        start_testu = millis();                                                      // znacka pro 2-sekundovy interval testovani zakmitu
        trvani_testu = 2000;                                                         // trvani testu se nastavi na 2 sekundy od prvniho pruchodu interruptem
        tlacitko = 2;                                                                // znacka, ze bylo stisknute tlacitko cislo 2 (dolu)
      }
    posledni_kmit = micros();                                                        // zaznam casu posledniho kmitnuti v mikrosekundach (kdyz je jen jeden zakmit, bude o neco vetsi nez prvni_zmena)
    zakmity ++;                                                                      // pricteni jednoho zakmitu
  }


void interOK(void)
  { 
    if (tlacitko == 0)
      {
        prvni_zmena = micros();                                                      // znacka pro vypocet delky kmitani v mikrosekundach
        start_testu = millis();                                                      // znacka pro 2-sekundovy interval testovani zakmitu
        trvani_testu = 2000;                                                         // trvani testu se nastavi na 2 sekundy od prvniho pruchodu interruptem
        tlacitko = 3;                                                                // znacka, ze bylo stisknute tlacitko cislo 3 (OK)
      }
    posledni_kmit = micros();                                                        // zaznam casu posledniho kmitnuti v mikrosekundach (kdyz je jen jeden zakmit, bude o neco vetsi nez prvni_zmena)
    zakmity ++;                                                                      // pricteni jednoho zakmitu
  }


void interTS(void)
  { 
    if (tlacitko == 0)
      {
        prvni_zmena = micros();                                                      // znacka pro vypocet delky kmitani v mikrosekundach
        start_testu = millis();                                                      // znacka pro 2-sekundovy interval testovani zakmitu
        trvani_testu = 2000;                                                         // trvani testu se nastavi na 2 sekundy od prvniho pruchodu interruptem
        tlacitko = 4;                                                                // znacka, ze bylo stisknute tlacitko cislo 4 (TimeStamp)
      }
    posledni_kmit = micros();                                                        // zaznam casu posledniho kmitnuti v mikrosekundach (kdyz je jen jeden zakmit, bude o neco vetsi nez prvni_zmena)
    zakmity ++;                                                                      // pricteni jednoho zakmitu
  }
