// ==============  sken I2C sbernice a vypis nalezenych periferii ====================
void sken_i2c(void)
  {
    zobraz_text(11);                                                  //  " i2C "
    Serial.print("Sken I2C\n|");
    for (byte i = 1; i < 127; i++)
      {
        if (i % 3 == 0)    Serial.print('-');
      }
    Serial.println('|');
    Serial.print('|');
    
    boolean zarizeni[128];
    for (byte i = 1; i < 127; i++)
      {
        Wire.beginTransmission (i);
        if (Wire.endTransmission () == 0)
          {
            zarizeni[i] = true;
          }
        else
          {
            zarizeni[i] = false;
            Wire.begin();
            delay(100);
          }
        if (i % 3 == 0)    Serial.print('#');
      }
    Serial.println('|');

    for (byte i = 1; i < 127; i++)
      {
        if (zarizeni[i] == true)
          {
            Serial.print ("Found address: ");
            Serial.print (i, DEC);
            Serial.print (" (0x");
            Serial.print (i, HEX);
            
            Serial.print (") ");
            switch(i)
              {
                case 23:  
                  Serial.print ("(GPS)");
                  break;

                case 25:  
                case 30:  
                  Serial.print ("(LSM303)");
                  break;


                case 32:  
                  Serial.print ("(Expander)");
                  break;
              
                case 41:  
                  Serial.print ("(TSL2591)");
                  break;

                case 80:  
                  Serial.print ("(EEPROM < 64kB)");
                  break;

                case 81:  
                  Serial.print ("(EEPROM > 64kB)");
                  break;

                case 87:  
                  Serial.print ("(Extra EEPROM)");
                  break;

                case 104:  
                  Serial.print ("(MPU-6050)");
                  break;

                case 118:  
                  Serial.print ("(BME280)");
                  break;
              }
            Serial.println (' ');
          }
      }
  }
// ====================  konec skenu I2C sbernice ===========================
